package com.maroontress.madangler.client.config;

import com.google.gwt.user.client.Window;
import com.google.gwt.user.client.ui.Button;
import com.google.gwt.user.client.ui.ClickListener;
import com.google.gwt.user.client.ui.DialogBox;
import com.google.gwt.user.client.ui.HTML;
import com.google.gwt.user.client.ui.HorizontalPanel;
import com.google.gwt.user.client.ui.VerticalPanel;
import com.google.gwt.user.client.ui.Widget;
import com.maroontress.madangler.client.TextBoxPanel;

/**
   ץåȥեԽǤ
*/
public class PlatformEditor extends DialogBox {

    /** 󥻥ܥ */
    private Button cancelButton;

    /** ԽλΥܥ*/
    private Button okButton;

    /** ʸå̾ */
    private CharsetListBox charset;

    /** ץΥǥ */
    private ConfigModel model;

    /** ⡼ȥޥ */
    private TextBoxPanel command;

    /** 桼@ۥ̾ */
    private TextBoxPanel host;

    /** ץåȥեΥǥå */
    private int index;

    /**
       ץåȥեԽޤ

       @param model ץΥǥ
    */
    public PlatformEditor(final ConfigModel model) {
	this.model = model;
	index = -1;
	host = new TextBoxPanel("User@Hostname", 64);
	command = new TextBoxPanel("Command", 64);
	charset = new CharsetListBox();

	cancelButton = new Button("Cancel");
	cancelButton.addClickListener(new ClickListener() {
	    public void onClick(final Widget sender) {
		hide();
	    }
	});

	okButton = new Button("Ok");
	okButton.addClickListener(new ClickListener() {
	    public void onClick(final Widget sender) {
		setPlatform();
	    }
	});

	HorizontalPanel bp = new HorizontalPanel();
	HTML space = new HTML("&nbsp;");
	bp.add(cancelButton);
	bp.add(space);
	bp.add(okButton);
	bp.setCellWidth(space, "100%");
	bp.setWidth("100%");

	VerticalPanel vp = new VerticalPanel();
	vp.add(new HTML("&nbsp;"));
	vp.add(host);
	vp.add(new HTML("&nbsp;"));
	vp.add(command);
	vp.add(new HTML("&nbsp;"));
	vp.add(new HTML("Charset"));
	vp.add(charset);
	vp.add(new HTML("&nbsp;"));
	vp.add(bp);

	setWidget(vp);
    }

    /**
       ץåȥեΥǥåꤷޤ

       @param i ץåȥեΥǥå
    */
    public void setPlatformIndex(final int i) {
	index = i;
	Platform p = model.getPlatform(index);
	setText("Edit: " + p.getId());
	host.setText(p.getHost());
	command.setText(p.getCommand());
	charset.setSelectedValue(p.getCharset());
    }

    /**
       ʸζޤ

       ζʸ󤬶ξϥǷٹ𤷡
       null֤ޤ

       @param s ζʸ
       @param label ٹ𤹤ȤɽʸΥ٥
       @return ʸ󡢷̤ξnull
    */
    private String trim(final String s, final String label) {
	// PlatformDialog.trim()Ȱ
	String t = s.trim();
	if (t.equals("")) {
	    Window.alert(label + " is empty.");
	    return null;
	}
	return t;
    }

    /**
       ץåȥեѹޤ
    */
    private void setPlatform() {
	String hostString = trim(host.getText(), "User@Hostname");
	String commandString = trim(command.getText(), "Command");
	String charsetString = charset.getSelectedValue();
	if (hostString == null || commandString == null) {
	    return;
	}
	String id = model.getPlatform(index).getId();
	Platform p = new Platform(id, hostString, commandString,
				  charsetString);
	model.setPlatform(index, p);
	model.notifyChanged();
	hide();
    }
}
